#!/bin/bash

. /usr/local/Reductor/etc/const
. $CONFIG

get_new_rpm() {
	curl "$(</tmp/reductor/new_rpm_url)" > /tmp/reductor.rpm
	curl -L "$(</tmp/reductor/new_rpm_url)".md5 > /tmp/reductor.rpm.md5_remote
	md5sum /tmp/reductor.rpm > /tmp/reductor.rpm.md5_local
	read md5remote _ < /tmp/reductor.rpm.md5_remote
	read md5local _ < /tmp/reductor.rpm.md5_local
	if [ "$md5remote" = "$md5local" ]; then
		echo "Скачанный RPM пакет не битый (md5 совпадает)"
	else
		echo 'Не совпадают контрольные суммы пакета, прерываю обновление!'
		echo 'Не совпадают контрольные суммы пакета, прерываю обновление!' > /tmp/alarm.msg
		send_alarm /tmp/alarm.msg
		return 4
	fi
}

copy_update() {
	cp -p $CONTRIB$UPDATER $UPDATER
	chmod a+x $UPDATER
}

main() {
	[ "$1" = 'auto' ] && auto=1
	if [ "$auto" != '1' ]; then
		ask "Обновить ${app['name']}" || __terminate "Не забудьте сделать это позже."
	fi
	check_connect_repo || __terminate "Нет доступа к репозиторию"
	check_version	|| __terminate "У вас уже установлена последняя версия Carbon Reductor!"
	get_new_rpm	|| __terminate "Не удалось скачать новый RPM-пакет"
	check_version	|| __terminate "Новая версия пока не выпущена, а обновляться на старые нельзя!"
	copy_update	|| __terminate "Не удалось скопировать bootstrap-скрипт обновления"
	exec $UPDATER	|| __terminate "Не удалось запустить bootstrap-скрипт обновления "
}

main "$@"
