#!/usr/bin/python -u
# coding: utf-8

from os import uname
from sys import stdin

domain_block = '/usr/local/Reductor/lists/https.resolv'

def dnsify_c(domain):
    if not domain.startswith('.'):
        domain = '.' + domain
    dots = [len(word) for word in domain.split('.')]
    if len(dots) > 0 and dots[0] == 0:
        dots = dots[1:]
    dots = ["%.2x" % dot for dot in dots]
    print_line = ", ".join(["0x%.2x" % (ord(char),) for char in domain])
    for dot in dots:
        print_line = print_line.replace('2e', dot, 1)
    print_line = domain[1:] + " = {" + print_line + "};"
    return print_line


def dnsify(domain):
    if not domain.startswith('.'):
        domain = '.' + domain
    dots = [len(word) for word in domain.split('.')]
    if len(dots) > 0 and dots[0] == 0:
        dots = dots[1:]
    dots = ["%.2x" % dot for dot in dots]
    print_line = " ".join(["%.2x" % (ord(char),) for char in domain])
    for dot in dots:
        print_line = print_line.replace('2e', dot, 1)
    return print_line


def dnsify_list(list_file=stdin):
    for line in list_file.xreadlines():
        try:
            domain = line.startswith('www.') and line[4:] or line
        except:
            raise Exception(line)
        print "%s %s |%s|" % (
            "add",
	    "0",
            dnsify(domain.strip().decode('utf-8').encode('idna'))
        )


if __name__ == '__main__':
    dnsify_list(open(domain_block))
