#!/bin/bash

. /usr/local/Reductor/etc/const
. $CONFIG

CUSTOM_EXIT=1
LOCKDIR=/var/lock/reductor/
LOCKFILE=$LOCKDIR/ip_update.sh.lock

trap __exit EXIT

__custom_exit() {
        flock -u 3
}

if [ "${filter['https_by_nslookup']}" = '0' ]; then
	log "Пропускаем nslookup https-ресурсов т.к. отключен в меню"
	exit 0
fi

export IPV6="${filter['ipv6']:-0}"
if [ -n "${filter['dns_ip']// /}" ]; then
	export DNS_BLACKHOLE_IP="${filter['dns_ip']// /}"
fi

if [ ! -s $LISTDIR/https.resolv ]; then
	log "Подозрительно, но $LISTDIR/https.resolv пустой, вероятно отключена фильтрация https / nslookup" >&2
	exit 0
fi
mkdir -p $LOCKDIR
exec 3>$LOCKFILE
echo "- Проверяем lock"
flock -x 3

. $CHROOTDIR/virtualenv/bin/activate
echo "- Кладём новые адреса в базу, если есть"
python -u $CHROOTDIR/virtualenv/bin/domain_update.py
echo "- Запускаем резолв для нужных ресурсов"
python -u $CHROOTDIR/virtualenv/bin/ip_update.py
rm -f /tmp/https_resolv.json.* || true
deactivate
