#!/bin/bash

. /usr/local/Reductor/etc/const
. $CONFIG
. $MENULIB

update_network=1

value() {
	eval echo "\${$var}"
}

update() {
	local var="$2"
	local value
	value="$(value "$var")"
	local prompt="$1 ($value): "
	read -p "$prompt" tmp
	[ -n "$tmp" ] && eval $var=\"$tmp\"
}

registration() {
	insert_module xt_reductor

	echo "На вопросы, на которые требуется ответ Да/Нет: 0 - нет, 1 - да"
	echo
	echo "# Информация для регистрации продукта"
	echo
	echo "Регистрация. Регномер: $($BINDIR/reg_util create)"

	while [ -z "$company_name" ]; do
		read -p "Регистрация. Название компании: " company_name
	done

	while [ -z "$email" ]; do
		read -p "Регистрация. E-mail: " email
	done

	read -p "Телефон для СМС уведомлений о проблемах (опционально): " phone

	export company_name email phone
	$BINDIR/reg_util update
	$BINDIR/reg_util activate
	$BINDIR/registration.sh activation
}

rkn_update() {
	echo
	echo "# Настройки обновления списков (также используются для регистрации и последующей продукта)"
	echo

	update "Включить автоматическое обновление единого реестра запрещённых сайтов?" autoupdate['enabled']
	if [ -z "${autoupdate['operator']}" ]; then
		autoupdate['operator']="$company_name"
	fi
	update "Название компании, без кавычек" autoupdate['operator']

	update "ИНН, 10 цифр" autoupdate['inn']
	update "ОГРН, 13 цифр" autoupdate['ogrn']

	if [ -z "${autoupdate['email']}" ]; then
		autoupdate['email']="$email"
	fi
	update "e-mail для РКН" autoupdate['email']
	save_and_exit
}

filter() {
	echo
	echo "# Настройки алгоритма фильтрации трафика"
	update "URL для редиректа HTTP-запросов" filter['forbidden_url']
	update "Фильтровать https по IP?" filter['https_by_ip']
	if [ "${filter['https_by_ip']}" = '1' ]; then
		update "Использовать дополнительно nslookup для resolv ip https-доменов?" filter['https_by_nslookup']
	fi
	update "Использовать DNS-фильтрацию?" filter['dns']
	if [ "${filter['dns']:-0}" = '1' ]; then
		if [ "${filter['dns_ip']}" = '127.0.0.1' ]; then
			filter['dns_ip']="$CARBONSOFT_BLACKHOLE"
		fi
		update "IP веб-сервера с заглушкой для редиректа:" filter['dns_ip']
		if [ "${filter['dns_ip']}" = "$CARBONSOFT_BLACKHOLE" ]; then
			echo
			echo "Вы решили использовать заглушку, предоставляемую Carbon Soft для демонстрации работы фильтрации DNS-трафика"
			echo "Рекомендуем после завершения тестирования установить заглушку на собственном сервере, либо прямо на Carbon Reductor"
			echo
		fi
		echo "Нужно сгенерировать SSL-ключи для nginx, чтобы работали редиректы HTTPS-запросов к запрещённым ресурсам."
		echo "Позже можно заменить /etc/nginx/ssl/cert.pem /etc/nginx/ssl/cert.key на другие."
		mkdir -p /etc/nginx/ssl/
		openssl req -new -x509 -days 9999 -nodes -newkey rsa:2048 -out /etc/nginx/ssl/cert.pem -keyout /etc/nginx/ssl/cert.key
	fi
	save_and_exit
}

admins() {
	echo
	echo "# Администраторы"
	update "Перечислите через пробел список IP адресов администраторов, у них будет доступ к веб-интерфейсу" admin['ip']
	update "IP адрес на котором будет доступен веб-интерфейс" admin['web_ip']
	[ "${admin['web_port']}" = '80' ] && admin['web_port']='8080'
	update "Порт на котором будет доступен веб-интерфейс" admin['web_port']
	save_and_exit
}

network() {
	update "Настроить сеть для приёма зеркала трафика со свитча?" update_network
	[ "$update_network" = '1' ] && /usr/local/Reductor/bin/setup_network.sh
}

main() {
	registration
	rkn_update
	filter
	admins
	network
	/etc/init.d/reductor restart
}

main
